diff --git a/modules/gui/qt4/dialogs/open.cpp b/modules/gui/qt4/dialogs/open.cpp
index ceb356f..3c48c2a 100644
--- a/modules/gui/qt4/dialogs/open.cpp
+++ b/modules/gui/qt4/dialogs/open.cpp
@@ -177,9 +177,9 @@ OpenDialog::OpenDialog( QWidget *parent,
     storedMethod = "";
     newCachingMethod( "file-caching" );
 
-    setMinimumSize( sizeHint() );
+    //setMinimumSize( sizeHint() );
     setMaximumWidth( 900 );
-    resize( getSettings()->value( "opendialog-size", QSize( 500, 490 ) ).toSize() );
+    resize( getSettings()->value( "opendialog-size", QSize( 500, 350 ) ).toSize() );
 }
 
 OpenDialog::~OpenDialog()
diff --git a/modules/gui/qt4/ui/open.ui b/modules/gui/qt4/ui/open.ui
index a374868..31373cf 100644
--- a/modules/gui/qt4/ui/open.ui
+++ b/modules/gui/qt4/ui/open.ui
@@ -33,29 +33,18 @@
    <item row="0" column="0" colspan="4">
     <widget class="QTabWidget" name="Tab"/>
    </item>
-   <item row="1" column="0" colspan="4">
-    <widget class="QCheckBox" name="advancedCheckBox">
-     <property name="toolTip">
-      <string>Show extended options</string>
-     </property>
-     <property name="text">
-      <string>Show &amp;more options</string>
-     </property>
-    </widget>
-   </item>
    <item row="2" column="0" colspan="4">
     <widget class="QGroupBox" name="advancedFrame">
      <layout class="QGridLayout" name="gridLayout_2">
-      <item row="0" column="0">
-       <widget class="QLabel" name="cacheLabel">
-        <property name="text">
-         <string>Caching</string>
-        </property>
-        <property name="buddy">
-         <cstring>cacheSpinBox</cstring>
-        </property>
-       </widget>
-      </item>
+      <property name="leftMargin">
+       <number>0</number>
+      </property>
+      <property name="topMargin">
+       <number>0</number>
+      </property>
+      <property name="verticalSpacing">
+       <number>4</number>
+      </property>
       <item row="0" column="2">
        <widget class="QSpinBox" name="cacheSpinBox">
         <property name="toolTip">
@@ -191,6 +180,16 @@
         </property>
        </widget>
       </item>
+      <item row="0" column="0">
+       <widget class="QLabel" name="cacheLabel">
+        <property name="text">
+         <string>Caching</string>
+        </property>
+        <property name="buddy">
+         <cstring>cacheSpinBox</cstring>
+        </property>
+       </widget>
+      </item>
      </layout>
     </widget>
    </item>
@@ -270,6 +269,16 @@
      </property>
     </widget>
    </item>
+   <item row="1" column="0" colspan="4">
+    <widget class="QCheckBox" name="advancedCheckBox">
+     <property name="toolTip">
+      <string>Show extended options</string>
+     </property>
+     <property name="text">
+      <string>Show &amp;more options</string>
+     </property>
+    </widget>
+   </item>
   </layout>
  </widget>
  <tabstops>
diff --git a/modules/gui/qt4/ui/open_disk.ui b/modules/gui/qt4/ui/open_disk.ui
index 57cb40a..663ea64 100644
--- a/modules/gui/qt4/ui/open_disk.ui
+++ b/modules/gui/qt4/ui/open_disk.ui
@@ -8,7 +8,7 @@
     <x>0</x>
     <y>0</y>
     <width>500</width>
-    <height>319</height>
+    <height>252</height>
    </rect>
   </property>
   <property name="minimumSize">
@@ -183,193 +183,169 @@
     </widget>
    </item>
    <item>
-    <widget class="QGroupBox" name="diskOptionBox">
+    <widget class="QGroupBox" name="groupBox">
      <property name="title">
-      <string>Starting Position</string>
+      <string/>
      </property>
-     <layout class="QHBoxLayout" name="horizontalLayout">
+     <layout class="QHBoxLayout" name="horizontalLayout_8">
       <item>
-       <widget class="QLabel" name="titleLabel">
-        <property name="text">
-         <string>Title</string>
-        </property>
-        <property name="buddy">
-         <cstring>titleSpin</cstring>
-        </property>
+       <widget class="QGroupBox" name="diskOptionBox_2">
+        <property name="title">
+         <string>Audio and Subtitles</string>
+        </property>
+        <layout class="QGridLayout" name="gridLayout_2">
+         <property name="leftMargin">
+          <number>0</number>
+         </property>
+         <property name="rightMargin">
+          <number>0</number>
+         </property>
+         <item row="0" column="0">
+          <widget class="QLabel" name="audioLabel">
+           <property name="enabled">
+            <bool>true</bool>
+           </property>
+           <property name="text">
+            <string>Audio track</string>
+           </property>
+           <property name="buddy">
+            <cstring>audioSpin</cstring>
+           </property>
+          </widget>
+         </item>
+         <item row="0" column="1">
+          <widget class="QSpinBox" name="audioSpin">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="alignment">
+            <set>Qt::AlignRight</set>
+           </property>
+           <property name="minimum">
+            <number>-1</number>
+           </property>
+           <property name="maximum">
+            <number>10</number>
+           </property>
+           <property name="value">
+            <number>-1</number>
+           </property>
+          </widget>
+         </item>
+         <item row="0" column="2">
+          <widget class="QLabel" name="subtitlesLabel">
+           <property name="text">
+            <string>Subtitles track</string>
+           </property>
+           <property name="buddy">
+            <cstring>subtitlesSpin</cstring>
+           </property>
+          </widget>
+         </item>
+         <item row="0" column="3">
+          <widget class="QSpinBox" name="subtitlesSpin">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="autoFillBackground">
+            <bool>false</bool>
+           </property>
+           <property name="alignment">
+            <set>Qt::AlignRight</set>
+           </property>
+           <property name="suffix">
+            <string/>
+           </property>
+           <property name="minimum">
+            <number>-1</number>
+           </property>
+           <property name="maximum">
+            <number>31</number>
+           </property>
+           <property name="value">
+            <number>-1</number>
+           </property>
+          </widget>
+         </item>
+        </layout>
        </widget>
       </item>
       <item>
-       <widget class="QSpinBox" name="titleSpin">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
-          <horstretch>0</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="autoFillBackground">
-         <bool>false</bool>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight</set>
-        </property>
-        <property name="value">
-         <number>0</number>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <spacer name="horizontalSpacer">
-        <property name="orientation">
-         <enum>Qt::Horizontal</enum>
-        </property>
-        <property name="sizeType">
-         <enum>QSizePolicy::Fixed</enum>
-        </property>
-        <property name="sizeHint" stdset="0">
-         <size>
-          <width>20</width>
-          <height>20</height>
-         </size>
-        </property>
-       </spacer>
-      </item>
-      <item>
-       <widget class="QLabel" name="chapterLabel">
-        <property name="text">
-         <string>Chapter</string>
-        </property>
-        <property name="buddy">
-         <cstring>chapterSpin</cstring>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <widget class="QSpinBox" name="chapterSpin">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
-          <horstretch>0</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight</set>
-        </property>
+       <widget class="QGroupBox" name="diskOptionBox">
+        <property name="title">
+         <string>Starting Position</string>
+        </property>
+        <layout class="QHBoxLayout" name="horizontalLayout">
+         <property name="leftMargin">
+          <number>0</number>
+         </property>
+         <property name="rightMargin">
+          <number>0</number>
+         </property>
+         <item>
+          <widget class="QLabel" name="titleLabel">
+           <property name="text">
+            <string>Title</string>
+           </property>
+           <property name="buddy">
+            <cstring>titleSpin</cstring>
+           </property>
+          </widget>
+         </item>
+         <item>
+          <widget class="QSpinBox" name="titleSpin">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="autoFillBackground">
+            <bool>false</bool>
+           </property>
+           <property name="alignment">
+            <set>Qt::AlignRight</set>
+           </property>
+           <property name="value">
+            <number>0</number>
+           </property>
+          </widget>
+         </item>
+         <item>
+          <widget class="QLabel" name="chapterLabel">
+           <property name="text">
+            <string>Chapter</string>
+           </property>
+           <property name="buddy">
+            <cstring>chapterSpin</cstring>
+           </property>
+          </widget>
+         </item>
+         <item>
+          <widget class="QSpinBox" name="chapterSpin">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="alignment">
+            <set>Qt::AlignRight</set>
+           </property>
+          </widget>
+         </item>
+        </layout>
        </widget>
       </item>
      </layout>
     </widget>
    </item>
-   <item>
-    <widget class="QGroupBox" name="diskOptionBox_2">
-     <property name="title">
-      <string>Audio and Subtitles</string>
-     </property>
-     <layout class="QGridLayout" name="gridLayout_2">
-      <item row="0" column="0">
-       <widget class="QLabel" name="audioLabel">
-        <property name="text">
-         <string>Audio track</string>
-        </property>
-        <property name="buddy">
-         <cstring>audioSpin</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="0" column="1">
-       <widget class="QSpinBox" name="audioSpin">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
-          <horstretch>0</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight</set>
-        </property>
-        <property name="minimum">
-         <number>-1</number>
-        </property>
-        <property name="maximum">
-         <number>10</number>
-        </property>
-        <property name="value">
-         <number>-1</number>
-        </property>
-       </widget>
-      </item>
-      <item row="0" column="2">
-       <spacer name="horizontalSpacer_2">
-        <property name="orientation">
-         <enum>Qt::Horizontal</enum>
-        </property>
-        <property name="sizeType">
-         <enum>QSizePolicy::Fixed</enum>
-        </property>
-        <property name="sizeHint" stdset="0">
-         <size>
-          <width>20</width>
-          <height>20</height>
-         </size>
-        </property>
-       </spacer>
-      </item>
-      <item row="0" column="3">
-       <widget class="QLabel" name="subtitlesLabel">
-        <property name="text">
-         <string>Subtitles track</string>
-        </property>
-        <property name="buddy">
-         <cstring>subtitlesSpin</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="0" column="4">
-       <widget class="QSpinBox" name="subtitlesSpin">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
-          <horstretch>0</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="autoFillBackground">
-         <bool>false</bool>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight</set>
-        </property>
-        <property name="suffix">
-         <string/>
-        </property>
-        <property name="minimum">
-         <number>-1</number>
-        </property>
-        <property name="maximum">
-         <number>31</number>
-        </property>
-        <property name="value">
-         <number>-1</number>
-        </property>
-       </widget>
-      </item>
-     </layout>
-    </widget>
-   </item>
-   <item>
-    <spacer>
-     <property name="orientation">
-      <enum>Qt::Vertical</enum>
-     </property>
-     <property name="sizeType">
-      <enum>QSizePolicy::MinimumExpanding</enum>
-     </property>
-     <property name="sizeHint" stdset="0">
-      <size>
-       <width>181</width>
-       <height>0</height>
-      </size>
-     </property>
-    </spacer>
-   </item>
   </layout>
  </widget>
  <tabstops>
@@ -382,8 +358,6 @@
   <tabstop>browseDiscButton</tabstop>
   <tabstop>titleSpin</tabstop>
   <tabstop>chapterSpin</tabstop>
-  <tabstop>subtitlesSpin</tabstop>
-  <tabstop>audioSpin</tabstop>
  </tabstops>
  <resources/>
  <connections/>
diff --git a/modules/gui/qt4/ui/open_file.ui b/modules/gui/qt4/ui/open_file.ui
index f4b2d83..9ff3e75 100644
--- a/modules/gui/qt4/ui/open_file.ui
+++ b/modules/gui/qt4/ui/open_file.ui
@@ -8,7 +8,7 @@
     <x>0</x>
     <y>0</y>
     <width>566</width>
-    <height>344</height>
+    <height>355</height>
    </rect>
   </property>
   <property name="sizePolicy">
@@ -67,10 +67,10 @@
         <property name="text">
          <string>Add...</string>
         </property>
-	<property name="icon">
+        <property name="icon">
          <iconset>
           <normaloff>:/playlist_add</normaloff>:/playlist_add</iconset>
-        </property>	
+        </property>
        </widget>
       </item>
       <item row="2" column="2">
@@ -78,10 +78,6 @@
         <property name="enabled">
          <bool>false</bool>
         </property>
-	<property name="icon">
-         <iconset>
-          <normaloff>:/playlist_remove</normaloff>:/playlist_remove</iconset>
-        </property>
         <property name="sizePolicy">
          <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
           <horstretch>0</horstretch>
@@ -91,6 +87,10 @@
         <property name="text">
          <string>Remove</string>
         </property>
+        <property name="icon">
+         <iconset>
+          <normaloff>:/playlist_remove</normaloff>:/playlist_remove</iconset>
+        </property>
        </widget>
       </item>
      </layout>
@@ -149,6 +149,16 @@
       <item>
        <widget class="QWidget" name="widget_2" native="true">
         <layout class="QGridLayout" name="gridLayout_2">
+         <item row="0" column="1">
+          <widget class="QComboBox" name="sizeSubComboBox">
+           <property name="minimumSize">
+            <size>
+             <width>100</width>
+             <height>0</height>
+            </size>
+           </property>
+          </widget>
+         </item>
          <item row="0" column="0">
           <widget class="QLabel" name="sizeSubLabel">
            <property name="sizePolicy">
@@ -171,7 +181,7 @@
            </property>
           </widget>
          </item>
-         <item row="1" column="0">
+         <item row="0" column="3">
           <widget class="QLabel" name="alignSubLabel">
            <property name="sizePolicy">
             <sizepolicy hsizetype="Minimum" vsizetype="Preferred">
@@ -190,20 +200,7 @@
            </property>
           </widget>
          </item>
-         <item row="0" column="2">
-          <spacer name="horizontalSpacer">
-           <property name="orientation">
-            <enum>Qt::Horizontal</enum>
-           </property>
-           <property name="sizeHint" stdset="0">
-            <size>
-             <width>40</width>
-             <height>20</height>
-            </size>
-           </property>
-          </spacer>
-         </item>
-         <item row="1" column="1">
+         <item row="0" column="4">
           <widget class="QComboBox" name="alignSubComboBox">
            <property name="minimumSize">
             <size>
@@ -213,15 +210,18 @@
            </property>
           </widget>
          </item>
-         <item row="0" column="1">
-          <widget class="QComboBox" name="sizeSubComboBox">
-           <property name="minimumSize">
+         <item row="0" column="5">
+          <spacer name="horizontalSpacer">
+           <property name="orientation">
+            <enum>Qt::Horizontal</enum>
+           </property>
+           <property name="sizeHint" stdset="0">
             <size>
-             <width>100</width>
-             <height>0</height>
+             <width>40</width>
+             <height>20</height>
             </size>
            </property>
-          </widget>
+          </spacer>
          </item>
         </layout>
        </widget>
@@ -229,22 +229,6 @@
      </layout>
     </widget>
    </item>
-   <item row="3" column="0">
-    <spacer>
-     <property name="orientation">
-      <enum>Qt::Vertical</enum>
-     </property>
-     <property name="sizeType">
-      <enum>QSizePolicy::MinimumExpanding</enum>
-     </property>
-     <property name="sizeHint" stdset="0">
-      <size>
-       <width>273</width>
-       <height>16</height>
-      </size>
-     </property>
-    </spacer>
-   </item>
   </layout>
  </widget>
  <tabstops>